diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/openflow/examples/openflow-switch.py ns-3.39/src/openflow/examples/openflow-switch.py
--- ns-3.38/src/openflow/examples/openflow-switch.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/openflow/examples/openflow-switch.py	2023-07-05 14:23:48.069428200 -0700
@@ -0,0 +1,85 @@
+#
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License version 2 as
+# published by the Free Software Foundation;
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+#
+# Author: Blake Hurd <naimorai@gmail.com>
+# Modified by: Josh Pelkey <joshpelkey@gmail.com>
+#              Gabriel Ferreira <gabrielcarvfer@gmail.com>
+#
+
+from ns import ns
+
+ns.LogComponentEnable("OpenFlowInterface", ns.LOG_LEVEL_ALL)
+ns.LogComponentEnable("OpenFlowSwitchNetDevice", ns.LOG_LEVEL_ALL)
+
+terminals = ns.NodeContainer()
+terminals.Create(4)
+
+csmaSwitch = ns.NodeContainer()
+csmaSwitch.Create(1)
+
+csma = ns.CsmaHelper()
+csma.SetChannelAttribute("DataRate", ns.DataRateValue(5000000))
+csma.SetChannelAttribute("Delay", ns.TimeValue(ns.MilliSeconds(2)))
+
+terminalDevices = ns.NetDeviceContainer()
+switchDevices = ns.NetDeviceContainer()
+for i in range(4):
+    container = ns.NodeContainer()
+    container.Add(terminals.Get(i))
+    container.Add(csmaSwitch)
+    link = csma.Install(container)
+    terminalDevices.Add(link.Get(0))
+    switchDevices.Add(link.Get(1))
+
+switchNode = csmaSwitch.Get(0)
+swtch = ns.OpenFlowSwitchHelper()
+controller = ns.ofi.DropController()
+# controller = ns.CreateObject("ns3::ofi::LearningController")
+swtch.Install(switchNode, switchDevices, controller)
+# controller->SetAttribute("ExpirationTime", TimeValue(timeout))
+
+
+internet = ns.InternetStackHelper()
+internet.Install(terminals)
+
+ipv4 = ns.Ipv4AddressHelper()
+ipv4.SetBase("10.1.1.0", "255.255.255.0")
+ipv4.Assign(terminalDevices)
+
+port = 9
+
+onoff = ns.OnOffHelper("ns3::UdpSocketFactory", ns.InetSocketAddress(ns.Ipv4Address("10.1.1.2"), port).ConvertTo())
+onoff.SetConstantRate(ns.DataRate("500kb/s"))
+
+app = onoff.Install(terminals.Get(0))
+
+app.Start(ns.Seconds(1.0))
+app.Stop(ns.Seconds(10.0))
+
+sink = ns.PacketSinkHelper("ns3::UdpSocketFactory",
+                           ns.InetSocketAddress(ns.Ipv4Address.GetAny(), port).ConvertTo())
+app = sink.Install(terminals.Get(1))
+app.Start(ns.Seconds(0.0))
+
+onoff.SetAttribute("Remote", ns.AddressValue(ns.InetSocketAddress(ns.Ipv4Address("10.1.1.1"), port).ConvertTo()))
+app = onoff.Install(terminals.Get(3))
+app.Start(ns.Seconds(1.1))
+app.Stop(ns.Seconds(10.0))
+
+app = sink.Install(terminals.Get(0))
+app.Start(ns.Seconds(0.0))
+
+ns.Simulator.Run()
+ns.Simulator.Destroy()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/openflow/model/openflow-switch-net-device.cc ns-3.39/src/openflow/model/openflow-switch-net-device.cc
--- ns-3.38/src/openflow/model/openflow-switch-net-device.cc	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/openflow/model/openflow-switch-net-device.cc	2023-07-05 14:23:48.069428200 -0700
@@ -984,7 +984,7 @@
 }
 
 void
-OpenFlowSwitchNetDevice::SendFlowExpired(sw_flow* flow, enum ofp_flow_expired_reason reason)
+OpenFlowSwitchNetDevice::SendFlowExpired(sw_flow* flow, ofp_flow_expired_reason reason)
 {
     ofpbuf* buffer;
     ofp_flow_expired* ofe =
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/openflow/model/openflow-switch-net-device.h ns-3.39/src/openflow/model/openflow-switch-net-device.h
--- ns-3.38/src/openflow/model/openflow-switch-net-device.h	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/openflow/model/openflow-switch-net-device.h	2023-07-05 14:23:48.069428200 -0700
@@ -400,7 +400,7 @@
      * \param flow The flow that expired.
      * \param reason The reason for sending this expiration notification.
      */
-    void SendFlowExpired(sw_flow* flow, enum ofp_flow_expired_reason reason);
+    void SendFlowExpired(sw_flow* flow, ofp_flow_expired_reason reason);
 
     /**
      * Send a reply about a Port's status to the controller.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/openflow/test/examples-to-run.py ns-3.39/src/openflow/test/examples-to-run.py
--- ns-3.38/src/openflow/test/examples-to-run.py	2023-03-16 20:54:23.812869000 -0700
+++ ns-3.39/src/openflow/test/examples-to-run.py	2023-07-05 14:23:48.069428200 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
@@ -17,4 +16,6 @@
 #     (example_name, do_run).
 #
 # See test.py for more information.
-python_examples = []
+python_examples = [
+    ("openflow-switch.py", "ENABLE_OPENFLOW == True"),
+]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/point-to-point/model/point-to-point-net-device.cc ns-3.39/src/point-to-point/model/point-to-point-net-device.cc
--- ns-3.38/src/point-to-point/model/point-to-point-net-device.cc	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/point-to-point/model/point-to-point-net-device.cc	2023-07-05 14:23:48.069428200 -0700
@@ -256,7 +256,7 @@
     Simulator::Schedule(txCompleteTime, &PointToPointNetDevice::TransmitComplete, this);
 
     bool result = m_channel->TransmitStart(p, this, txTime);
-    if (result == false)
+    if (!result)
     {
         m_phyTxDropTrace(p);
     }
@@ -520,7 +520,7 @@
     // If IsLinkUp() is false it means there is no channel to send any packet
     // over so we just hit the drop trace on the packet and return an error.
     //
-    if (IsLinkUp() == false)
+    if (!IsLinkUp())
     {
         m_macTxDropTrace(packet);
         return false;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/point-to-point/test/examples-to-run.py ns-3.39/src/point-to-point/test/examples-to-run.py
--- ns-3.38/src/point-to-point/test/examples-to-run.py	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/point-to-point/test/examples-to-run.py	2023-07-05 14:23:48.069428200 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/propagation/model/jakes-process.cc ns-3.39/src/propagation/model/jakes-process.cc
--- ns-3.38/src/propagation/model/jakes-process.cc	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/propagation/model/jakes-process.cc	2023-07-05 14:23:48.073428200 -0700
@@ -143,12 +143,12 @@
 std::complex<double>
 JakesProcess::GetComplexGain() const
 {
-    std::complex<double> sumAplitude = std::complex<double>(0, 0);
+    std::complex<double> sumAmplitude = std::complex<double>(0, 0);
     for (unsigned int i = 0; i < m_oscillators.size(); i++)
     {
-        sumAplitude += m_oscillators[i].GetValueAt(Now());
+        sumAmplitude += m_oscillators[i].GetValueAt(Now());
     }
-    return sumAplitude;
+    return sumAmplitude;
 }
 
 double
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/propagation/model/three-gpp-propagation-loss-model.cc ns-3.39/src/propagation/model/three-gpp-propagation-loss-model.cc
--- ns-3.38/src/propagation/model/three-gpp-propagation-loss-model.cc	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/propagation/model/three-gpp-propagation-loss-model.cc	2023-07-05 14:23:48.073428200 -0700
@@ -144,6 +144,12 @@
     return m_frequency;
 }
 
+bool
+ThreeGppPropagationLossModel::IsO2iLowPenetrationLoss(Ptr<const ChannelCondition> cond) const
+{
+    return DoIsO2iLowPenetrationLoss(cond);
+}
+
 double
 ThreeGppPropagationLossModel::DoCalcRxPower(double txPowerDbm,
                                             Ptr<MobilityModel> a,
@@ -179,17 +185,26 @@
     if (cond->GetO2iCondition() == ChannelCondition::O2iConditionValue::O2I &&
         m_buildingPenLossesEnabled)
     {
-        if (cond->GetO2iLowHighCondition() == ChannelCondition::O2iLowHighConditionValue::LOW)
+        if (IsO2iLowPenetrationLoss(cond))
         {
             rxPow -= GetO2iLowPenetrationLoss(a, b, cond->GetLosCondition());
         }
-        else if (cond->GetO2iLowHighCondition() == ChannelCondition::O2iLowHighConditionValue::HIGH)
+        else
         {
             rxPow -= GetO2iHighPenetrationLoss(a, b, cond->GetLosCondition());
         }
+    }
+    else if (cond->GetO2iCondition() == ChannelCondition::O2iConditionValue::I2I &&
+             cond->GetLosCondition() == ChannelCondition::LosConditionValue::NLOS &&
+             m_buildingPenLossesEnabled)
+    {
+        if (IsO2iLowPenetrationLoss(cond))
+        {
+            rxPow -= GetO2iLowPenetrationLoss(a, b, cond->GetLosCondition());
+        }
         else
         {
-            NS_ABORT_MSG("If we have set the O2I condition, we shouldn't be here");
+            rxPow -= GetO2iHighPenetrationLoss(a, b, cond->GetLosCondition());
         }
     }
 
@@ -368,6 +383,23 @@
     return o2iLossValue;
 }
 
+bool
+ThreeGppPropagationLossModel::DoIsO2iLowPenetrationLoss(Ptr<const ChannelCondition> cond) const
+{
+    if (cond->GetO2iLowHighCondition() == ChannelCondition::O2iLowHighConditionValue::LOW)
+    {
+        return true;
+    }
+    else if (cond->GetO2iLowHighCondition() == ChannelCondition::O2iLowHighConditionValue::HIGH)
+    {
+        return false;
+    }
+    else
+    {
+        NS_ABORT_MSG("If we have set the O2I condition, we shouldn't be here");
+    }
+}
+
 double
 ThreeGppPropagationLossModel::GetLossNlosv(double distance2D,
                                            double distance3D,
@@ -547,6 +579,15 @@
     return std::min(m_randomO2iVar1->GetValue(0, 10), m_randomO2iVar2->GetValue(0, 10));
 }
 
+bool
+ThreeGppRmaPropagationLossModel::DoIsO2iLowPenetrationLoss(Ptr<const ChannelCondition> cond
+                                                           [[maybe_unused]]) const
+{
+    // Based on 3GPP 38.901 7.4.3.1 in RMa only low losses are applied.
+    // Therefore enforce low losses.
+    return true;
+}
+
 double
 ThreeGppRmaPropagationLossModel::GetLossLos(double distance2D,
                                             double distance3D,
@@ -1163,7 +1204,7 @@
         // We cannot know who is the BS and who is the UT, we assume that the
         // tallest node is the BS and the smallest is the UT
         hBs = std::max(za, zb);
-        hUt = std::min(za, za);
+        hUt = std::min(za, zb);
     }
 
     return std::pair<double, double>(hUt, hBs);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/propagation/model/three-gpp-propagation-loss-model.h ns-3.39/src/propagation/model/three-gpp-propagation-loss-model.h
--- ns-3.38/src/propagation/model/three-gpp-propagation-loss-model.h	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/propagation/model/three-gpp-propagation-loss-model.h	2023-07-05 14:23:48.073428200 -0700
@@ -78,6 +78,14 @@
      */
     double GetFrequency() const;
 
+    /**
+     * \brief Return true if the O2I Building Penetration loss
+     *        corresponds to a low loss condition.
+     * \param cond The ptr to the channel condition model
+     * \return True for low loss, false for high
+     */
+    bool IsO2iLowPenetrationLoss(Ptr<const ChannelCondition> cond) const;
+
   private:
     /**
      * Computes the received power by applying the pathloss model described in
@@ -174,6 +182,20 @@
                                              ChannelCondition::LosConditionValue cond) const;
 
     /**
+     * \brief Indicates the condition of the o2i building penetration loss
+     *        (defined in 3GPP TR 38.901 7.4.3.1).
+     *        The default implementation returns the condition as set
+     *        (either based on the buildings materials, or if the probabilistic
+     *        model is used in the ThreeGppChannelConditionModel, then
+     *        based on the result of a random variable).
+     *        The derived classes can change the default behavior by overriding
+     *        this method.
+     * \param cond the ptr to the channel condition model
+     * \return True for low losses, false for high losses
+     */
+    virtual bool DoIsO2iLowPenetrationLoss(Ptr<const ChannelCondition> cond) const;
+
+    /**
      * \brief Computes the pathloss between a and b considering that the line of
      *        sight is obstructed
      * \param distance2D the 2D distance between tx and rx in meters
@@ -375,6 +397,14 @@
     double GetO2iDistance2dIn() const override;
 
     /**
+     * \brief Indicates the condition of the o2i building penetration loss
+     *        (defined in 3GPP TR 38.901 7.4.3.1).
+     * \param cond the ptr to the channel condition model
+     * \return True for low losses, false for high losses
+     */
+    bool DoIsO2iLowPenetrationLoss(Ptr<const ChannelCondition> cond) const override;
+
+    /**
      * \brief Computes the pathloss between a and b considering that the line of
      *        sight is obstructed
      * \param distance2D the 2D distance between tx and rx in meters
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/propagation/test/examples-to-run.py ns-3.39/src/propagation/test/examples-to-run.py
--- ns-3.38/src/propagation/test/examples-to-run.py	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/propagation/test/examples-to-run.py	2023-07-05 14:23:48.073428200 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/sixlowpan/model/sixlowpan-header.cc ns-3.39/src/sixlowpan/model/sixlowpan-header.cc
--- ns-3.38/src/sixlowpan/model/sixlowpan-header.cc	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/sixlowpan/model/sixlowpan-header.cc	2023-07-05 14:23:48.073428200 -0700
@@ -167,7 +167,7 @@
         break;
     }
 
-    if (m_tcflCompression == false)
+    if (!m_tcflCompression)
     {
         serializedSize += 4;
     }
@@ -253,7 +253,7 @@
         break;
     }
 
-    if (m_tcflCompression == false)
+    if (!m_tcflCompression)
     {
         i.WriteU8(m_trafficClass);
         uint8_t temp[3];
@@ -347,7 +347,7 @@
         break;
     }
 
-    if (m_tcflCompression == false)
+    if (!m_tcflCompression)
     {
         m_trafficClass = i.ReadU8();
         uint8_t temp[3];
@@ -938,7 +938,7 @@
     default:
         break;
     }
-    if (GetNh() == false)
+    if (!GetNh())
     {
         serializedSize++;
     }
@@ -949,7 +949,7 @@
     switch (GetSam())
     {
     case HC_INLINE:
-        if (GetSac() == false)
+        if (!GetSac())
         {
             serializedSize += 16;
         }
@@ -964,12 +964,12 @@
     default:
         break;
     }
-    if (GetM() == false)
+    if (!GetM())
     {
         switch (GetDam())
         {
         case HC_INLINE:
-            if (GetDac() == false)
+            if (!GetDac())
             {
                 serializedSize += 16;
             }
@@ -990,7 +990,7 @@
         switch (GetDam())
         {
         case HC_INLINE:
-            if (GetDac() == false)
+            if (!GetDac())
             {
                 serializedSize += 16;
             }
@@ -1000,20 +1000,20 @@
             }
             break;
         case HC_COMPR_64:
-            if (GetDac() == false)
+            if (!GetDac())
             {
                 serializedSize += 6;
             }
             break;
         case HC_COMPR_16:
-            if (GetDac() == false)
+            if (!GetDac())
             {
                 serializedSize += 4;
             }
             break;
         case HC_COMPR_0:
         default:
-            if (GetDac() == false)
+            if (!GetDac())
             {
                 serializedSize++;
             }
@@ -1065,7 +1065,7 @@
         break;
     }
     // Next Header
-    if (GetNh() == false)
+    if (!GetNh())
     {
         i.WriteU8(m_nextHeader);
     }
@@ -1078,7 +1078,7 @@
     switch (GetSam())
     {
     case HC_INLINE:
-        if (GetSac() == false)
+        if (!GetSac())
         {
             i.Write(m_srcInlinePart, 16);
         }
@@ -1094,7 +1094,7 @@
         break;
     }
     // Destination Address
-    if (GetM() == false)
+    if (!GetM())
     {
         // unicast
         switch (GetDam())
@@ -1184,7 +1184,7 @@
         break;
     }
     // Next Header
-    if (GetNh() == false)
+    if (!GetNh())
     {
         m_nextHeader = i.ReadU8();
     }
@@ -1210,7 +1210,7 @@
     switch (GetSam())
     {
     case HC_INLINE:
-        if (GetSac() == false)
+        if (!GetSac())
         {
             i.Read(m_srcInlinePart, 16);
         }
@@ -1228,7 +1228,7 @@
 
     // Destination Address
     memset(m_dstInlinePart, 0x00, sizeof(m_dstInlinePart));
-    if (GetM() == false)
+    if (!GetM())
     {
         // unicast
         switch (GetDam())
@@ -1552,7 +1552,7 @@
 SixLowPanNhcExtension::GetSerializedSize() const
 {
     uint32_t serializedSize = 2;
-    if (GetNh() == false)
+    if (!GetNh())
     {
         serializedSize++;
     }
@@ -1564,7 +1564,7 @@
 {
     Buffer::Iterator i = start;
     i.WriteU8(m_nhcExtensionHeader);
-    if (GetNh() == false)
+    if (!GetNh())
     {
         i.WriteU8(m_nhcNextHeader);
     }
@@ -1577,7 +1577,7 @@
 {
     Buffer::Iterator i = start;
     m_nhcExtensionHeader = i.ReadU8();
-    if (GetNh() == false)
+    if (!GetNh())
     {
         m_nhcNextHeader = i.ReadU8();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/sixlowpan/model/sixlowpan-net-device.cc ns-3.39/src/sixlowpan/model/sixlowpan-net-device.cc
--- ns-3.38/src/sixlowpan/model/sixlowpan-net-device.cc	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/sixlowpan/model/sixlowpan-net-device.cc	2023-07-05 14:23:48.073428200 -0700
@@ -1095,7 +1095,6 @@
         uint8_t addressBuf[16];
 
         // This is just to limit the scope of some variables.
-        if (true)
         {
             Ipv6Address srcAddr = ipHeader.GetSource();
             uint8_t srcContextId;
@@ -1197,7 +1196,6 @@
         }
 
         // This is just to limit the scope of some variables.
-        if (true)
         {
             Ipv6Address dstAddr = ipHeader.GetDestination();
             dstAddr.GetBytes(addressBuf);
@@ -1427,8 +1425,8 @@
                 return true;
             }
 
-            uint8_t contexPrefix[16];
-            m_contextTable[contextId].contextPrefix.GetBytes(contexPrefix);
+            uint8_t contextPrefix[16];
+            m_contextTable[contextId].contextPrefix.GetBytes(contextPrefix);
             uint8_t contextLength = m_contextTable[contextId].contextPrefix.GetPrefixLength();
 
             uint8_t srcAddress[16] = {};
@@ -1453,13 +1451,13 @@
             // Do not combine the prefix - we want to override the bytes.
             for (uint8_t i = 0; i < bytesToCopy; i++)
             {
-                srcAddress[i] = contexPrefix[i];
+                srcAddress[i] = contextPrefix[i];
             }
             if (bitsToCopy)
             {
                 uint8_t addressBitMask = (1 << (8 - bitsToCopy)) - 1;
                 uint8_t prefixBitMask = ~addressBitMask;
-                srcAddress[bytesToCopy] = (contexPrefix[bytesToCopy] & prefixBitMask) |
+                srcAddress[bytesToCopy] = (contextPrefix[bytesToCopy] & prefixBitMask) |
                                           (srcAddress[bytesToCopy] & addressBitMask);
             }
             ipHeader.SetSource(Ipv6Address::Deserialize(srcAddress));
@@ -1524,11 +1522,11 @@
             return true;
         }
 
-        uint8_t contexPrefix[16];
-        m_contextTable[contextId].contextPrefix.GetBytes(contexPrefix);
+        uint8_t contextPrefix[16];
+        m_contextTable[contextId].contextPrefix.GetBytes(contextPrefix);
         uint8_t contextLength = m_contextTable[contextId].contextPrefix.GetPrefixLength();
 
-        if (encoding.GetM() == false)
+        if (!encoding.GetM())
         {
             // unicast
             uint8_t dstAddress[16] = {};
@@ -1553,13 +1551,13 @@
             // Do not combine the prefix - we want to override the bytes.
             for (uint8_t i = 0; i < bytesToCopy; i++)
             {
-                dstAddress[i] = contexPrefix[i];
+                dstAddress[i] = contextPrefix[i];
             }
             if (bitsToCopy)
             {
                 uint8_t addressBitMask = (1 << (8 - bitsToCopy)) - 1;
                 uint8_t prefixBitMask = ~addressBitMask;
-                dstAddress[bytesToCopy] = (contexPrefix[bytesToCopy] & prefixBitMask) |
+                dstAddress[bytesToCopy] = (contextPrefix[bytesToCopy] & prefixBitMask) |
                                           (dstAddress[bytesToCopy] & addressBitMask);
             }
             ipHeader.SetDestination(Ipv6Address::Deserialize(dstAddress));
@@ -1572,7 +1570,7 @@
             dstAddress[0] = 0xff;
             memcpy(dstAddress + 1, encoding.GetDstInlinePart(), 2);
             dstAddress[3] = contextLength;
-            memcpy(dstAddress + 4, contexPrefix, 8);
+            memcpy(dstAddress + 4, contextPrefix, 8);
             memcpy(dstAddress + 12, encoding.GetDstInlinePart() + 2, 4);
             ipHeader.SetDestination(Ipv6Address::Deserialize(dstAddress));
         }
@@ -1580,7 +1578,7 @@
     else
     {
         // Destination address compression uses stateless compression.
-        if (encoding.GetM() == false)
+        if (!encoding.GetM())
         {
             // unicast
             if (encoding.GetDam() == SixLowPanIphc::HC_INLINE)
@@ -1697,7 +1695,7 @@
                                                                   dst,
                                                                   ipHeader.GetSource(),
                                                                   ipHeader.GetDestination());
-            if (retval.second == true)
+            if (retval.second)
             {
                 return true;
             }
@@ -2485,7 +2483,7 @@
             FragmentsTimeoutsListI_t iter = m_timeoutEventList.begin();
             FragmentKey_t oldestKey = std::get<1>(*iter);
 
-            std::list<Ptr<Packet>> storedFragments = m_fragments[oldestKey]->GetFraments();
+            std::list<Ptr<Packet>> storedFragments = m_fragments[oldestKey]->GetFragments();
             for (std::list<Ptr<Packet>>::iterator fragIter = storedFragments.begin();
                  fragIter != storedFragments.end();
                  fragIter++)
@@ -2612,11 +2610,7 @@
         }
     }
 
-    if (ret && (lastEndOffset == m_packetSize))
-    {
-        return true;
-    }
-    return false;
+    return ret && lastEndOffset == m_packetSize;
 }
 
 Ptr<Packet>
@@ -2658,7 +2652,7 @@
 }
 
 std::list<Ptr<Packet>>
-SixLowPanNetDevice::Fragments::GetFraments() const
+SixLowPanNetDevice::Fragments::GetFragments() const
 {
     std::list<Ptr<Packet>> fragments;
     std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator iter;
@@ -2687,7 +2681,7 @@
     NS_LOG_FUNCTION(this);
 
     MapFragments_t::iterator it = m_fragments.find(key);
-    std::list<Ptr<Packet>> storedFragments = it->second->GetFraments();
+    std::list<Ptr<Packet>> storedFragments = it->second->GetFragments();
     for (std::list<Ptr<Packet>>::iterator fragIter = storedFragments.begin();
          fragIter != storedFragments.end();
          fragIter++)
@@ -2873,7 +2867,7 @@
     {
         ContextEntry context = iter.second;
 
-        if ((context.compressionAllowed == true) && (context.validLifetime > Simulator::Now()))
+        if (context.compressionAllowed && context.validLifetime > Simulator::Now())
         {
             if (address.HasPrefix(context.contextPrefix))
             {
@@ -2902,7 +2896,7 @@
     {
         ContextEntry context = iter.second;
 
-        if ((context.compressionAllowed == true) && (context.validLifetime > Simulator::Now()))
+        if (context.compressionAllowed && context.validLifetime > Simulator::Now())
         {
             uint8_t contextLength = context.contextPrefix.GetPrefixLength();
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/sixlowpan/model/sixlowpan-net-device.h ns-3.39/src/sixlowpan/model/sixlowpan-net-device.h
--- ns-3.38/src/sixlowpan/model/sixlowpan-net-device.h	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/sixlowpan/model/sixlowpan-net-device.h	2023-07-05 14:23:48.073428200 -0700
@@ -510,7 +510,7 @@
          * \brief Get a list of the current stored fragments.
          * \returns The current stored fragments.
          */
-        std::list<Ptr<Packet>> GetFraments() const;
+        std::list<Ptr<Packet>> GetFragments() const;
 
         /**
          * \brief Set the Timeout iterator.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/sixlowpan/test/mock-net-device.cc ns-3.39/src/sixlowpan/test/mock-net-device.cc
--- ns-3.38/src/sixlowpan/test/mock-net-device.cc	2023-03-16 20:54:23.816869300 -0700
+++ ns-3.39/src/sixlowpan/test/mock-net-device.cc	2023-07-05 14:23:48.073428200 -0700
@@ -245,11 +245,7 @@
 MockNetDevice::IsPointToPoint() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_pointToPointMode)
-    {
-        return true;
-    }
-    return false;
+    return m_pointToPointMode;
 }
 
 bool
@@ -305,11 +301,7 @@
 MockNetDevice::NeedsArp() const
 {
     NS_LOG_FUNCTION(this);
-    if (m_pointToPointMode)
-    {
-        return false;
-    }
-    return true;
+    return !m_pointToPointMode;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/CMakeLists.txt ns-3.39/src/spectrum/CMakeLists.txt
--- ns-3.38/src/spectrum/CMakeLists.txt	2023-03-16 20:54:23.820869200 -0700
+++ ns-3.39/src/spectrum/CMakeLists.txt	2023-07-05 14:23:48.073428200 -0700
@@ -10,6 +10,7 @@
     model/friis-spectrum-propagation-loss.cc
     model/half-duplex-ideal-phy-signal-parameters.cc
     model/half-duplex-ideal-phy.cc
+    model/ism-spectrum-value-helper.cc
     model/matrix-based-channel-model.cc
     model/microwave-oven-spectrum-value-helper.cc
     model/two-ray-spectrum-propagation-loss-model.cc
@@ -26,6 +27,7 @@
     model/spectrum-model.cc
     model/spectrum-phy.cc
     model/spectrum-propagation-loss-model.cc
+    model/spectrum-transmit-filter.cc
     model/phased-array-spectrum-propagation-loss-model.cc
     model/spectrum-signal-parameters.cc
     model/spectrum-value.cc
@@ -49,6 +51,7 @@
     model/friis-spectrum-propagation-loss.h
     model/half-duplex-ideal-phy-signal-parameters.h
     model/half-duplex-ideal-phy.h
+    model/ism-spectrum-value-helper.h
     model/matrix-based-channel-model.h
     model/microwave-oven-spectrum-value-helper.h
     model/two-ray-spectrum-propagation-loss-model.h
@@ -65,6 +68,7 @@
     model/spectrum-model.h
     model/spectrum-phy.h
     model/spectrum-propagation-loss-model.h
+    model/spectrum-transmit-filter.h
     model/phased-array-spectrum-propagation-loss-model.h
     model/spectrum-signal-parameters.h
     model/spectrum-value.h
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/examples/adhoc-aloha-ideal-phy.cc ns-3.39/src/spectrum/examples/adhoc-aloha-ideal-phy.cc
--- ns-3.38/src/spectrum/examples/adhoc-aloha-ideal-phy.cc	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/examples/adhoc-aloha-ideal-phy.cc	2023-07-05 14:23:48.077428300 -0700
@@ -21,6 +21,7 @@
 #include <ns3/applications-module.h>
 #include <ns3/core-module.h>
 #include <ns3/friis-spectrum-propagation-loss.h>
+#include <ns3/ism-spectrum-value-helper.h>
 #include <ns3/log.h>
 #include <ns3/mobility-module.h>
 #include <ns3/network-module.h>
@@ -31,7 +32,6 @@
 #include <ns3/spectrum-model-300kHz-300GHz-log.h>
 #include <ns3/spectrum-model-ism2400MHz-res1MHz.h>
 #include <ns3/waveform-generator.h>
-#include <ns3/wifi-spectrum-value-helper.h>
 
 #include <iostream>
 #include <string>
@@ -176,7 +176,7 @@
     SpectrumChannelHelper channelHelper = SpectrumChannelHelper::Default();
     Ptr<SpectrumChannel> channel = channelHelper.Create();
 
-    WifiSpectrumValue5MhzFactory sf;
+    SpectrumValue5MhzFactory sf;
 
     double txPower = 0.1; // Watts
     uint32_t channelNumber = 1;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/examples/adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc ns-3.39/src/spectrum/examples/adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc
--- ns-3.38/src/spectrum/examples/adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/examples/adhoc-aloha-ideal-phy-matrix-propagation-loss-model.cc	2023-07-05 14:23:48.077428300 -0700
@@ -21,6 +21,7 @@
 #include <ns3/applications-module.h>
 #include <ns3/core-module.h>
 #include <ns3/friis-spectrum-propagation-loss.h>
+#include <ns3/ism-spectrum-value-helper.h>
 #include <ns3/log.h>
 #include <ns3/mobility-module.h>
 #include <ns3/network-module.h>
@@ -31,7 +32,6 @@
 #include <ns3/spectrum-model-300kHz-300GHz-log.h>
 #include <ns3/spectrum-model-ism2400MHz-res1MHz.h>
 #include <ns3/waveform-generator.h>
-#include <ns3/wifi-spectrum-value-helper.h>
 
 #include <iomanip>
 #include <iostream>
@@ -163,7 +163,7 @@
     channelHelper.AddPropagationLoss(propLoss);
     Ptr<SpectrumChannel> channel = channelHelper.Create();
 
-    WifiSpectrumValue5MhzFactory sf;
+    SpectrumValue5MhzFactory sf;
 
     uint32_t channelNumber = 1;
     Ptr<SpectrumValue> txPsd = sf.CreateTxPowerSpectralDensity(txPowerW, channelNumber);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/spectrum/examples/adhoc-aloha-ideal-phy-with-microwave-oven.cc ns-3.39/src/spectrum/examples/adhoc-aloha-ideal-phy-with-microwave-oven.cc
--- ns-3.38/src/spectrum/examples/adhoc-aloha-ideal-phy-with-microwave-oven.cc	2023-03-16 20:54:23.824869200 -0700
+++ ns-3.39/src/spectrum/examples/adhoc-aloha-ideal-phy-with-microwave-oven.cc	2023-07-05 14:23:48.077428300 -0700
@@ -21,6 +21,7 @@
 #include <ns3/applications-module.h>
 #include <ns3/core-module.h>
 #include <ns3/friis-spectrum-propagation-loss.h>
+#include <ns3/ism-spectrum-value-helper.h>
 #include <ns3/log.h>
 #include <ns3/microwave-oven-spectrum-value-helper.h>
 #include <ns3/mobility-module.h>
@@ -35,7 +36,6 @@
 #include <ns3/spectrum-model-ism2400MHz-res1MHz.h>
 #include <ns3/waveform-generator-helper.h>
 #include <ns3/waveform-generator.h>
-#include <ns3/wifi-spectrum-value-helper.h>
 
 #include <iostream>
 #include <string>
@@ -196,7 +196,7 @@
     // Configure ofdm nodes
     ////////////////////////
 
-    WifiSpectrumValue5MhzFactory sf;
+    SpectrumValue5MhzFactory sf;
 
     double txPower = 0.1; // Watts
     uint32_t channelNumber = 4;
